{
PanGen - Gerador de panning
Por Lucas Alexandre
Em Fev/16
}

program PanGen;
uses
dvCrt, dvWin, SDL_Mixer, sound, sysutils, windows;

var
ch: integer;
audiofile: PMix_Chunk;
pan1,pan2: integer;
output: file of pMix_chunk;
veloc: integer;

procedure Init;
begin
sintInic(0,'');
sintetiza('PanGen');
pan1:=255;
pan2:=255;
veloc:=1;
end;

procedure loadfile;
var filename: string;
begin
sintWriteln('Nome do arquivo: ');
sintReadln(filename);
if fileExists(filename) then
mix_haltchannel(ch);
ch:=play(filename,-1);
assign(output,'pangen.raw');
rewrite(output);
end;

procedure prog;
var c: char;
chunkin: pMix_chunk;
begin
if mix_playing(ch)<>0 then
begin
chunkin:=mix_getchunk(ch);
blockwrite(output,chunkin.abuf^,sizeof(chunkin.abuf^));
end;
if keypressed then c:=upcase(readkey);
case c of
F1: loadfile;
F3:
begin
if veloc=1 then exit;
dec(veloc);
end;
F4:
begin
if veloc=5 then exit;
inc(veloc);
end;
#32:
begin
if Mix_paused(ch)<>0 then
Mix_Resume(ch)
else
Mix_Pause(ch);
end;
{ Panning features }
'R': {Reset}
begin
pan1:=255;
pan2:=255;
Mix_SetPanning(ch,pan1,pan2);
end;
#75:
begin
if (pan2=0) and (pan2=255) then exit;
if pan1=255 then pan1:=0;
pan1:=pan1-veloc; pan2:=pan2+veloc; Mix_SetPanning(ch,pan2,pan1);
end;
#77:
begin
if (pan1=255) and (pan2=0) then exit;
if pan2=255 then pan2:=0;
pan2:=pan2-veloc; pan1:=pan1+veloc; Mix_SetPanning(ch,pan2,pan1);
end;
end;
end;

begin
Init;
while true do Prog;
end.
